#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

int insertZelda(char*zeldawii, char*zeldagc)
{
    char *zeldagci = NULL;
    char *zeldadat = NULL;

    FILE * pFile;
    long lSize;
    size_t result;

//Load zeldaTp.dat
    pFile = fopen ( zeldawii , "rb" );
    if (pFile==NULL) {printf("Can't open %s!\n", zeldawii); return -1;}

    // obtain file size:
        fseek (pFile , 0 , SEEK_END);
        lSize = ftell (pFile);
        rewind (pFile);

    // allocate memory to contain the whole file:
        zeldadat = (char*) malloc (sizeof(char)*lSize);
        if (zeldadat == NULL) {
                printf ("Memory error\n");
                if (zeldadat != NULL) free (zeldadat);
                fclose (pFile);
                getchar();
                return -1;
        }
    // copy the file into the buffer:
        result = fread (zeldadat,1,lSize,pFile);
        if (result != lSize) {
            printf ("Reading error\n");
            if (zeldadat != NULL) free (zeldadat);
            fclose (pFile);
            getchar();
            return -1;
            }
    // the whole file is now loaded in the memory buffer.
    // terminate
        fclose (pFile);

  /* the whole file is now loaded in the memory buffer. */

//Load savegame.gci
    pFile = fopen ( zeldagc , "rb" );
    if (pFile==NULL) {printf("Can't open %s!\n", zeldagc); return -1;}

    // obtain file size:
        fseek (pFile , 0 , SEEK_END);
        lSize = ftell (pFile);
        rewind (pFile);

    // allocate memory to contain the whole file:
        zeldagci = (char*) malloc (sizeof(char)*lSize);
        if (zeldagci == NULL) {
                printf ("Memory error\n");
                if (zeldagci != NULL) free (zeldagci);
                if (zeldadat != NULL) free (zeldadat);
                fclose (pFile);
                getchar();
                return -1;
        }
    // copy the file into the buffer:
        result = fread (zeldagci,1,lSize,pFile);
        if (result != lSize) {
            printf ("Reading error\n");
            if (zeldagci != NULL) free (zeldagci);
            if (zeldadat != NULL) free (zeldadat);
            fclose (pFile);
            getchar();
            return -1;
            }
    // the whole file is now loaded in the memory buffer.
    // terminate
        fclose (pFile);

  /* the whole file is now loaded in the memory buffer. */


    pFile = fopen ( "zeldaTp.gci", "wb" );
    result = fwrite (zeldagci , 1 , 64+(8192*2) , pFile );
    if (result != 64+(8192*2)) {
            printf ("Writing error\n");
            if (zeldagci != NULL) free (zeldagci);
            if (zeldadat != NULL) free (zeldadat);
            fclose (pFile);
            getchar();
            return -1;
        }
    result = fwrite (zeldadat , 1 , 8192*2 , pFile );
    if (result != 8192*2) {
            printf ("Writing error\n");
            if (zeldagci != NULL) free (zeldagci);
            if (zeldadat != NULL) free (zeldadat);
            fclose (pFile);
            getchar();
            return -1;
        }
    fclose (pFile);
    if (zeldagci != NULL) free (zeldagci);
    if (zeldadat != NULL) free (zeldadat);
    printf("zeldaTp.gci created\n");
    printf("Now put it in dolphin with the memory card manager or insert to memory card with GCMM 1.2d, CTR-GCS 0.3b or original CTR-GCS over BBA");


    return 1;
}

int extractZelda(char*file)
{
    char *zeldagci = NULL;

    FILE * pFile;
    long lSize;
    size_t result;

//Load header 1
    pFile = fopen ( file , "rb" );
    if (pFile==NULL) {printf("Can't open %s!\n", file); return -1;}

    // obtain file size:
        fseek (pFile , 0 , SEEK_END);
        lSize = ftell (pFile);
        rewind (pFile);

    // allocate memory to contain the whole file:
        zeldagci = (char*) malloc (sizeof(char)*lSize);
        if (zeldagci == NULL) {
                printf ("Memory error\n");
                if (zeldagci != NULL) free (zeldagci);
                fclose (pFile);
                getchar();
                return -1;
        }
    // copy the file into the buffer:
        result = fread (zeldagci,1,lSize,pFile);
        if (result != lSize) {
            printf ("Reading error\n");
            if (zeldagci != NULL) free (zeldagci);
            fclose (pFile);
            getchar();
            return -1;
            }
    // the whole file is now loaded in the memory buffer.
    // terminate
        fclose (pFile);

  /* the whole file is now loaded in the memory buffer. */


    pFile = fopen ( "zeldaTp.dat", "wb" );
    result = fwrite (zeldagci+64+(8192*2) , 1 , 8192*2 , pFile );
    if (result != 8192*2) {
            printf ("Writing error\n");
            if (zeldagci != NULL) free (zeldagci);
            fclose (pFile);
            getchar();
            return -1;
        }
    fclose (pFile);
    if (zeldagci != NULL) free (zeldagci);
    printf("zeldaTp.dat created\n\n");
    printf("Now put it in dolphin or substitue it in an existing Savegame Manager extracted savegame to install on wii (or directly copy it to emulated nand if you know the savegame path)\n");
    printf(" PAL   save path: nand:/title/00010000/525a4450/data/zeldaTp.dat\n");
    printf("NTSC-U save path: nand:/title/00010000/525a4445/data/zeldaTp.dat\n");
    printf("NTSC-J save path: nand:/title/00010000/525a444A/data/zeldaTp.dat\n");
    printf("NTSC-K save path: nand:/title/00010000/525a444B/data/zeldaTp.dat\n");


    return 1;
}

int main ( int argc, char *argv[] )
{


#ifdef DEBUG
//Endianess check

   int i = 1;
   char *p = (char *) &i;
   if ( p[0] == 1 )
        printf("Little Endian\n\n");
   else
        printf("Big Endian\n\n");
#endif

    printf("\n\n");
    printf("\t\t---------------------------");
    printf("\n\t\tZelda Twilight Princess\n\t\tSave converter 0.1 by suloku 2012\n");
    printf("\t\t---------------------------");
    printf("\n\n");

    if(argc>1){
        if (!strcmp(argv[1], "--help")){
            printf("This program will either extract a Zelda Twilight Princess GameCube savegame from a GCI file or insert a Wii savegame (zeldaTp.dat) to an existing Zelda TP gci gamecube savegame\n\n");
            printf( "Usage:\n");
            printf("Extract GC savegame for wii: zeldaTPconverter.exe zeldagamecube.gci\n");
            printf("Insert Wii savegame to gamecube GCI: zeldaTPconverter.exe zeldaTp.dat zeldagamecube.gci\n");
            goto exit;
        }else if (argc == 2){
            extractZelda(argv[1]);
        }else if (argc == 3){
            insertZelda(argv[1], argv[2]);
        }else{
            printf("This program will either extract a Zelda Twilight Princess GameCube savegame from a GCI file or insert a Wii savegame (zeldaTp.dat) to an existing Zelda TP gci gamecube savegame\n\n");
            printf( "Usage:\n");
            printf("Extract GC savegame for wii: zeldaTPconverter.exe zeldagamecube.gci\n");
            printf("Insert Wii savegame to gamecube GCI: zeldaTPconverter.exe zeldaTp.dat zeldagamecube.gci\n");
            goto exit;
        }

    }else{
            printf("This program will either extract a Zelda Twilight Princess GameCube savegame from a GCI file or insert a Wii savegame (zeldaTp.dat) to an existing Zelda TP gci gamecube savegame\n\n");
            printf( "Usage:\n");
            printf("Extract GC savegame for wii: zeldaTPconverter.exe zeldagamecube.gci\n");
            printf("Insert Wii savegame to gamecube GCI: zeldaTPconverter.exe zeldaTp.dat zeldagamecube.gci\n");
            goto exit;
    }


exit:

    printf("\n\n------------------------");
    printf("\n\n...Press return key to exit...");
    getchar();
    return 0;
}
